"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.compose = void 0;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

/**
 *
 * @param {*} e any type of argument
 * @returns {*} the same argument
 */
var identity = function identity(e) {
  return e;
};
/**
 *
 * @param  {...Functions} funcs a group of functions to compose
 * @param {...any} arguments to apply to the first function from the right
 * @returns the result of evaluation the arguments onto the functions, from right to left
 */


var compose = function compose() {
  for (var _len = arguments.length, funcs = new Array(_len), _key = 0; _key < _len; _key++) {
    funcs[_key] = arguments[_key];
  }

  return function () {
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return [identity].concat(funcs).reduceRight(function (val, func, i, src) {
      return i === src.length - 1 ? func.apply(void 0, _toConsumableArray(val)) : func(val);
    }, args);
  };
};

exports.compose = compose;
var _default = compose;
exports["default"] = _default;